 /*
Routine to identify sources from positions determined by midisky program.

April 2003 Niels Lund
*/

#include<stdio.h>
#include<math.h>
#include<stdlib.h>
#include<string.h>

#define srcnum		3500
#define NN		1000

/*#include<dos.h>*/

double rad2g;

void sortmin(float ia[], int N, int oa[]);
void sortmax(float ia[], int N, int oa[]);
int near(float racat[], float decat[], int snum, float dlim, float ra, float dec, int *k2min, float *r2min);
float charsum(char name[], int n);
void gengnu(char *datnavn, int orbit, int T_bin);

/* ***************************************************************************** */

main(int argc, char *argv[])
{
	FILE *fim, *in, *pofil, *gnufil, *cat, *ncat, *newcat, *datfil, *gogofil;
        char iname[200], iname2[100], b_file[100], iline[300], d, cdum[50], srcnames[srcnum][25];
        char p_name[100][25], altnames[srcnum][25], goodnames[srcnum][25], datnavn[200], gnunavn[200];
        char catname[200], sweethome[200], ch, catnames[srcnum][25];
        float ra[srcnum], nH[srcnum], intens[srcnum], param1[srcnum], param2[srcnum], r2min;
        float decl[srcnum], racat[srcnum], decat[srcnum], srcRA0[5], srcdec0[5], r_alt[srcnum];
        float goodra[srcnum], gooddec[srcnum], f_ser[srcnum];
        int serial[srcnum], orbitfirst=0, newpid, njwmax, isdcmax, igrmax, oa[srcnum], g_alt[srcnum];
        int n_pid[100], p_pid[100][100], p_orb[100][100], g_pid[NN], g_ser[NN], p_ser[100], g_orb[NN];
        int g_src[NN], n_src[NN], n, dob_orbit, k2min, kmin, pn_alt[srcnum], iq;
        
        int i, ii, j, jj, k, l, orbit, yymmdd, pid, dum, m0[4], mmm0, nn, nnn, old, unident, ucases, imax; 
        int jemx, cases, p_src[100], code, dtpe, gn_src[NN], pidv, jjg, eeval, jjgst, xtemax, ijk, ddd;

        float j_RA[2], j_dec[2], cosdec[2], cospos, sinpos, dist1, dist2;
        float avX, avY, s_dec, s_RA, phaX, phaY, offX, offY, offs[2], maxdist, list_RA[1000], list_dec[1000];
        float posang, dur, str1, str2, Xcenter, Ycenter, Zcenter, Xsrc, Ysrc, Zsrc, XYRsrc, srcQ, srcR;
        float avXL[NN], avYL[NN], offset, Lscale, s_wgt[NN], fitcnt, totcnt, scale, scaleX, scaleY;
        float SNmin[4], SNmax[4], ph_sign, ph_mag, dist, mmmdst, mmmdst2, mindst, mindst2, rmsdst, x2x, y2y;
        float Xcorr, Ycorr, minoffX, minoffY, minphase2, gminoffX, gminoffY, gminphase2, gminscaleX, gminscaleY;
        float p_sn[100], pr_alt[srcnum], gr_alt[srcnum];
        float g_ee[NN], g_x[NN], g_y[NN], g_RA[NN], g_dec[NN], g_r[NN], g_SN[NN], m_RA, m_dec, rdif;
        float p_wgt[100], p_x[100], p_y[100], p_r[100], p_ra[100], p_dec[100];

        double RA, dec, posvink, SRC_R, SRCX, SRCY, SRCZ, phas[2], meanR[4], meand[4], twopi, p_limit;
        double pix2rad, phas2[2], RAdif2, decdif2, mR1[4], mR2[4], md1[4], md2[4], mw0[4], mmmwgt;
        double radif, decdif;

/*        sprintf(sweethome, "/home/nl/Mail/midisky_docs/midi_test/work"); */
	sprintf(sweethome, "/nfs/r6/jemx/nlwork/midi_distribution_2/work");

        rad2g = 180.0 / 3.14159;
        twopi = 3.14159 * 2.0;
        pix2rad = 0.05224 / rad2g;
        p_limit = 0.06;
        
/*        gogofil = fopen("go_go_f2lx", "wt");
        fprintf(gogofil, "#! /bin/tcsh -f\n");
*/        
        sprintf(catname, "%s/reference/cat_combine.txt", sweethome);    
        pofil = fopen(catname, "rt");
        if (pofil == NULL) {printf("No catalog file found in %s\n", catname); return;}
              
        k = l = 0;
        for (i=0; i<3000; i++) {
           if (i > srcnum) {
              printf("Too many entries in the catalog: %6d, local srcnum maximum: %5d\n", i, srcnum);
              return;
           } 

           fgets(iline, 300, pofil);
           if (feof(pofil)) goto p_enda;
           
           sscanf(iline, "%20c", catnames[k]);
           sscanf(&iline[21], "%f %f %d", &racat[k], &decat[k], &serial[k]);

           k++;
        }

p_enda: 
        imax = k;
/*        printf("Final number of entries in the catalog: %6d,  Last entry:", imax);

        printf("%20s  ", catnames[imax-1]);
        printf("%8.4f  ", racat[imax-1]);
        printf("%+8.4f\n", decat[imax-1]);
        
        sortmin(racat, imax, oa);
        
        printf("%20s  ", catnames[imax-1]);
        printf("%8.4f  ", racat[imax-1]);
        printf("%+8.4f\n", decat[imax-1]);
        
        newcat = fopen("newcat.txt", "wt");
        
        for (i=0; i<imax; i++) {
           printf("%20s %8.4f %8.4f\n", catnames[oa[i]], racat[oa[i]], decat[oa[i]]);
           fprintf(newcat, "%20s   %8.4f   %8.4f  %4d\n", catnames[oa[i]], racat[oa[i]], decat[oa[i]], i);
        }
        fclose(newcat);
*/
        cat = fopen("jmx_cat.txt", "rt");
        if (cat == NULL) {
           jjg = 0;
           cat = fopen("jmx_cat.txt", "wt");
           fprintf(cat, "  # orb pid sub jmx E   maskX   maskY  offax  fitcnt   totcnt    SN   RA_jmx   dec_jmx");
           fprintf(cat, "    srcname           RA_cat   dec_cat\n");
        } else {
           jjg = 0;
           for (i=0; i=1000000; i++) {
              fgets(iline, 300, cat);
              if (feof(cat)) goto p_end0;
              jjg++;
           }
        }
p_end0:
        fclose(cat);
        jjgst = jjg;
   
        cat = fopen("jmx_cat.txt", "at");

	if (argc > 1) strcpy(iname, argv[1]) ;
        else {printf("input_file\n"); return;}

	strcpy(b_file, iname);
	strcpy(iname2, iname);
        strcat(iname, ".cat");
        in = fopen(iname,"rt");
	if ( in == NULL)
	{
	  printf("Error opening file: %s ..... exiting!\n", iname) ;
	  return ;
	}

        strcat(b_file, ".idt");
        fim = fopen(b_file, "wt");
        if (fim == NULL) printf("Could not open %s\n", b_file);

/*        strcat(iname2, ".gna");
        gnufil = fopen(iname2, "wt");
        if (gnufil == NULL) printf("Could not open %s\n", iname2);
*/                       
p_end1: for (j=0; j<300; j++) iline[j] = 0;
        fgets(iline, 300, in);
        if (feof(in)) goto end;
           
        sscanf(iline, "%d", &n);
        if (n < 1) goto p_end1;			/* skip to end of text section */

        i = strlen(iline);
        if (i < 10) goto p_end1;

        nnn = 0;
        unident = 10000;
        dob_orbit = 0;
        
        for (jj=0; jj<1000; jj++)		/* read list of sources found by midisky */
	{
              if (jj > 0) {
                 for (j=0; j<300; j++) iline[j] = 0;
                 fgets(iline, 300, in);
                 
              }
              if (feof(in)) goto end;
              
              i = strlen(iline);
              if (i < 10) {jj--; continue;}

              sscanf(iline, "%d", &n);
              if (n > 2) goto end;

              sscanf(iline, "%d %d %d %d %d %d %d", &n, &nn, &orbit, &pid, &pidv, &jemx, &eeval);
                 sscanf(&iline[28], "%f %f %f %f %f %f", &avX, &avY, &fitcnt, &totcnt, &m_RA, &m_dec);              

/*              printf("after read: %3d %3d %3d %2d %1d %1d %8.4f %8.4f %8.1f %8.1f %8.4f %8.4f\n", 
                 jj, orbit, pid, pidv, jemx, eeval, avX, avY, fitcnt, totcnt, m_RA, m_dec);              
*/              
              if (orbitfirst == 0) orbitfirst = orbit;
              else if (orbit != orbitfirst) dob_orbit = 1;
              
              g_pid[jj] = pid * 100 + pidv;
              g_orb[jj] = orbit;
              
              g_ee[jj] = eeval;
              g_x[jj] = avX;
              g_y[jj] = avY;
              g_RA[jj] = m_RA;
              g_dec[jj] = m_dec;
              g_r[jj] = sqrt((double)((avX-127.0)*(avX-127.0) + (avY-127.0)*(avY-127.0))) * pix2rad * rad2g;
              g_SN[jj] = fitcnt / sqrt((double)(totcnt));
              
              g_src[jj] = g_ser[jj] = unident;		/* initially, assume the source is a new source */

              kmin = near(racat, decat, imax, p_limit, m_RA, m_dec, &k2min, &r2min);

              if (kmin >= 0) g_src[jj] = g_ser[jj] = kmin; else unident++;
              g_alt[jj] = k2min;
              r_alt[jj] = r2min;
                 
              nnn = jj + 1;

              fprintf(cat, "%3d %3d %3d %2d %3d %2d ", jjg, orbit, pid, pidv, jemx+1, eeval);

              fprintf(cat, "%7.3f %7.3f %5.1f %8.1f %8.1f %6.2f %8.4f %+8.4f ", 
                 avX, avY, g_r[jj], fitcnt, totcnt, g_SN[jj], m_RA, m_dec);

              k = g_src[jj];
              if (k < 10000) fprintf(cat, "%s %8.4f %+7.4f\n", catnames[k], racat[k], decat[k]);
              else fprintf(cat, "\n");

              jjg++;
        }

end:
        cases = 0;			/* number of identified sources */
        ucases = 0;			/* number of new sources (uncatalogued) */
        if (nnn == 0) {
           printf("No sources found in %s\n", iname);
           fprintf(fim, "No sources found in %s\n", iname);
           goto fileclose;
        }
        
        nnn--;
        
        for (i=0; i<100; i++) {
           n_src[i] = 0;
           n_pid[i] = 0;
           for (jj=0; jj<100; jj++) p_pid[i][jj] = -1;
        }
        
        for (jj=0; jj<=nnn; jj++) {	/* loop over event list to generate list of detected sources */
           
           old = 0;			/* initially, assume this source has not been identified before */
           if (cases > 0) {
              for (i=0; i<cases; i++) {
                 if (p_src[i] == g_src[jj]) {
                    n_src[i]++;

                    newpid = 1;
                    for (k=0; k<n_pid[i]; k++) 
                       if ((g_pid[jj] == p_pid[i][k]) && (g_orb[jj] == p_orb[i][k])) newpid = 0;
                    if (newpid == 1) {
                       n_src[i] += 999;
                       p_pid[i][n_pid[i]] = g_pid[jj];
                       p_orb[i][n_pid[i]] = g_orb[jj];
                       n_pid[i]++;
                       if (n_pid[i] > 99) n_pid[i] = 99;
                    }
                    
                    p_wgt[i] += g_SN[jj] * g_SN[jj];
                    old = 1;
                 }

                 if ((p_src[i] >= 10000) && (g_src[jj] >= 10000)) {	
                    /* two unidentified sources may be the same new source */
                    radif = (g_RA[jj] - p_ra[i]) * cos(g_dec[jj] / rad2g);
                    decdif = g_dec[jj] - p_dec[i];
                    rdif = sqrt(radif*radif + decdif*decdif);

                    if (rdif < p_limit * 1.41) {
                       n_src[i]++;

                       newpid = 1;
                       for (k=0; k<n_pid[i]; k++) 
                          if ((g_pid[jj] == p_pid[i][k]) && (g_orb[jj] == p_orb[i][k])) newpid = 0;
                       if (newpid == 1) {
                          n_src[i] += 999;
                          p_pid[i][n_pid[i]] = g_pid[jj];
                          p_orb[i][n_pid[i]] = g_orb[jj];
                          n_pid[i]++;
                          if (n_pid[i] > 99) n_pid[i] = 99;
                       }
                    
                       p_ra[i] = (p_ra[i] * p_wgt[i] + g_RA[jj] * g_SN[jj] * g_SN[jj]);
                       p_dec[i] = (p_dec[i] * p_wgt[i] + g_dec[jj] * g_SN[jj] * g_SN[jj]);
                       p_wgt[i] += g_SN[jj] * g_SN[jj];
                       p_ra[i] /= p_wgt[i];
                       p_dec[i] /= p_wgt[i];
                       old = 1;
                    }
                 }

              }
           }   
           if (old == 0) {
              n_src[cases] = 1;
              p_pid[cases][n_pid[cases]] = g_pid[jj]; 
              p_orb[cases][n_pid[cases]] = g_orb[jj]; 
              n_pid[cases] = 1;
              p_wgt[cases] = g_SN[jj] * g_SN[jj];
              p_src[cases] = g_src[jj];
              p_ser[cases] = g_ser[jj];
              p_x[cases] = g_x[jj];
              p_y[cases] = g_y[jj];
              p_r[cases] = g_r[jj];
              pn_alt[cases] = g_alt[jj];
              pr_alt[cases] = r_alt[jj];
              
              if (g_src[jj] < 10000) {
                 p_ra[cases] = racat[g_src[jj]];
                 p_dec[cases] = decat[g_src[jj]];
                 strcpy(p_name[cases], catnames[g_src[jj]]);
              } else {
                 p_ra[cases] = g_RA[jj];
                 p_dec[cases] = g_dec[jj];
                 ucases++;
                 sprintf(p_name[cases], "    UIGR_%05d%+04d ", 
                    (int)(g_RA[jj]*100.0 + 0.5), (int)(g_dec[jj] * 100.0 + 0.5));
              }              
              cases++;
           }
        }
        fclose(in);
                
        printf("%3d sources found in %s\n", cases, iname);
        fprintf(fim, "%3d sources found in %s\n", cases, iname);
        
        for (i=0; i<cases; i++) {
           p_sn[i] = sqrt((double)(p_wgt[i]));
/*           printf(" %2d %s RA/dec: %8.3f %+7.3f cases: %6d SN:%8.3f ser: %6d N: %3d ", 
              i, p_name[i], p_ra[i], p_dec[i], n_src[i], p_sn[i], p_ser[i], n_pid[i]);
*/
           k = 110;
/*           if (dob_orbit == 0) {
              for (ii=0; ii<n_pid[i]; ii++) {
                 if ((p_pid[i][ii] % 100) == 0) {
                    printf(" %d", p_pid[i][ii]/100);
                    k += 4;
                 } else {
                    if (p_pid[i][ii] < 100000) {
                       printf(" %6.2f", (float)(p_pid[i][ii])/100.0);
                       k += 8;
                    } else {
                       printf(" %8.2f", (float)(p_pid[i][ii])/100.0);
                       k += 9;
                    }
                 }
                 if (k > 140) {
                    printf(" #\n");
                    k = 0;
                 }
              }
           } else {
              for (ii=0; ii<n_pid[i]; ii++) {
                 if ((p_pid[i][ii] % 100) == 0) {
                    printf(" %d-%d", p_orb[i][ii], p_pid[i][ii]/100);
                    k += 7;
                 } else {
                    if (p_pid[i][ii] < 100000) {
                       printf(" %d-%6.2f", p_orb[i][ii], (float)(p_pid[i][ii])/100.0);
                       k += 11;
                    } else {
                       printf(" %d-%8.2f", p_orb[i][ii], (float)(p_pid[i][ii])/100.0);
                       k += 13;
                    }
                 }
                 if (k > 140) {
                    printf(" #\n");
                    k = 0;
                 }
              }
           }

           printf("\n");
*/
           fprintf(fim, "%2d %s RA/dec: %8.3f %+7.3f cases: %6d SN: %8.3f ser: %6d N: %3d", 
              i, p_name[i], p_ra[i], p_dec[i], n_src[i], p_sn[i], p_ser[i], n_pid[i]);
              
           k = 0;
           for (ddd=0; ddd<200; ddd++) datnavn[ddd] = gnunavn[ddd] = 0;              
           sprintf(datnavn, "%s", p_name[i]);
           for (ddd=0; ddd<=strlen(datnavn); ddd++) {
              if ((datnavn[ddd] == ' ') && (k == 0)) {
                 for (k=0; k<198; k++) datnavn[k] = datnavn[k+1];
                 k = 0;
                 ddd--;
                 continue;
              } else k = 1;
              if (datnavn[ddd] == ' ') datnavn[ddd] = '_';
              if (datnavn[ddd] == ',') datnavn[ddd] = '_';
              if (datnavn[ddd] == '/') datnavn[ddd] = '_';
           }
more_q:    ddd = strlen(datnavn);
           if (datnavn[ddd-1] == '_') {
              for (k=ddd-1; k<198; k++) datnavn[k] = datnavn[k+1];
              goto more_q;
           }


           sprintf(gnunavn, "gnu_%s_%03d", datnavn, p_orb[i][0]);

/*           fprintf(gogofil, "./go_f2lx %s\n", datnavn);
           fprintf(gogofil, "gnuplot %s_E0\n", gnunavn);
           fprintf(gogofil, "gnuplot %s_E1\n", gnunavn);
           fprintf(gogofil, "gnuplot %s_E2\n", gnunavn);
           fprintf(gogofil, "gnuplot %s_E3\n", gnunavn);
           fprintf(gogofil, "mv lc4_0.gnu lc4_0_%s.gnu\n", gnunavn);
           fprintf(gogofil, "mv lc4_1.gnu lc4_1_%s.gnu\n", gnunavn);
           fprintf(gogofil, "mv lc4_2.gnu lc4_2_%s.gnu\n", gnunavn);
           fprintf(gogofil, "mv lc4_3.gnu lc4_3_%s.gnu\n", gnunavn);
           fprintf(gogofil, "mv lci_0.gnu lci_0_%s.gnu\n", gnunavn);
           fprintf(gogofil, "mv lci_1.gnu lci_1_%s.gnu\n", gnunavn);
           fprintf(gogofil, "mv lci_2.gnu lci_2_%s.gnu\n", gnunavn);
           fprintf(gogofil, "mv lci_3.gnu lci_3_%s.gnu\n", gnunavn);
           fprintf(gogofil, "mv lc8_1.gnu lc8_1_%s.gnu\n", gnunavn);
           fprintf(gogofil, "mv lcb_1.gnu lcb_1_%s.gnu\n", gnunavn);
           fprintf(gogofil, "mv lcc_1.gnu lcc_1_%s.gnu\n", gnunavn);
           fprintf(gogofil, "mv lcd_1.gnu lcd_1_%s.gnu\n", gnunavn);
*/           
           k = 2000;
           if (p_sn[i] > 10) k = 1000;
           if (p_sn[i] > 20) k = 500;
           if (p_sn[i] > 40) k = 250;
           if (p_sn[i] > 80) k = 100;

/*           gengnu(datnavn, p_orb[i][0], k);
*/
/*           strcat(datnavn, ".dat");
           datfil = fopen(datnavn, "wt");
           fprintf(datfil, "%8.4f  %8.4f  %d\n", p_ra[i], p_dec[i], k);
           fclose(datfil);
*/
           k = 110;
           if (dob_orbit == 0) {
              for (ii=0; ii<n_pid[i]; ii++) {
                 if ((p_pid[i][ii] % 100) == 0) {
                    fprintf(fim, " %d", p_pid[i][ii]/100);
                    k += 4;
                 } else {
                    if (p_pid[i][ii] < 100000) {
                       fprintf(fim, " %6.2f", (float)(p_pid[i][ii])/100.0);
                       k += 8;
                    } else {
                       fprintf(fim, " %8.2f", (float)(p_pid[i][ii])/100.0);
                       k += 9;
                    }
                 }
                 if (k > 150) {
                    fprintf(fim, " #\n");
                    k = 0;
                 }
              }
           } else {
              for (ii=0; ii<n_pid[i]; ii++) {
                 if ((p_pid[i][ii] % 100) == 0) {
                    fprintf(fim, " %d-%d", p_orb[i][ii], p_pid[i][ii]/100);
                    k += 7;
                 } else {
                    if (p_pid[i][ii] < 100000) {
                       fprintf(fim, " %d-%6.2f", p_orb[i][ii], (float)(p_pid[i][ii])/100.0);
                       k += 11;
                    } else {
                       fprintf(fim, " %d-%8.2f", p_orb[i][ii], (float)(p_pid[i][ii])/100.0);
                       k += 13;
                    }
                 }
                 if (k > 150) {
                    fprintf(fim, " #\n");
                    k = 0;
                 }
              }
           }
           if (p_ser[i] < 10000) fprintf(fim, "\n");
           else fprintf(fim, "   near %20s d =%5.1f\n", catnames[pn_alt[i]], pr_alt[i]); 
        }
        
/*        fclose(gogofil);
*/        
/*        for (i=0; i<cases; i++) {
           if (p_src[i] < 10000) fprintf(gnufil, "%+7.3f %+7.3f\n", p_ra[i], p_dec[i]);
        }
        
        fprintf(gnufil, "\n\n");

        for (i=0; i<cases; i++) {
           if ((p_src[i] >= 10000) && (n_src[i] >= 1000))
                 fprintf(gnufil, "%+7.3f %+7.3f\n", p_ra[i], p_dec[i]);
        }
        fprintf(gnufil, "\n\n");

        for (i=0; i<cases; i++) {
           if (p_src[i] >= 10000) 
              if ((p_sn[i] > 6.0) && (n_src[i] < 1000))
                 fprintf(gnufil, "%+7.3f %+7.3f\n", p_ra[i], p_dec[i]);
        }
        fprintf(gnufil, "\n\n");

        for (i=0; i<cases; i++) {
           if (p_src[i] >= 10000) 
              if ((p_sn[i] < 6.0) && (n_src[i] < 1000))
                 fprintf(gnufil, "%+7.3f %+7.3f\n", p_ra[i], p_dec[i]);
        }
        fprintf(gnufil, "\n\n");
*/
fileclose:
/*        fclose(gnufil);
*/
        fclose(fim);

/*        printf("wrote to gnufil\n");
*/
        imax = 0;
   	ucases = 10000;
        in = fopen("allsources.idt","rt") ;
	if ( in == NULL) goto firstsum;

        fgets(iline, 100, in);
        if (feof(in)) goto sum_end;
        
        imax = 0;
        sscanf(iline, "%d", &imax);	/* get number of entries in the existing summary list */

        if (imax > NN) {
           printf("Too many entries in the summary list: %6d\n", imax);
           return;
        } else printf("previous entries in the summary list: %6d\n", imax);

        for (i=0; i<imax; i++) {
/*           printf("Reading old catalog: imax: %3d\n", imax);
           for (ijk=0; ijk<imax; ijk++) printf(" %7.3f", ra[ijk]);
           printf("\n");
*/
           fgets(iline, 300, in);
           if (feof(in)) goto sum_end;
           
/*           printf("%s", iline);
*/
           sscanf(iline, "%d", &k);
           sscanf(&iline[7], "%20c", srcnames[i]);
           sscanf(&iline[29], "%f %f %d %f %d", &ra[i], &decl[i], &gn_src[i], &g_SN[i], &g_ser[i]);
           g_SN[i] = g_SN[i] * g_SN[i];
/*           printf("   %4d %20s %7.3f %8.3f %6d %8.2f %6d ",
              k, srcnames[i], ra[i], decl[i], gn_src[i], g_SN[i], g_ser[i]);
*/
           if (g_ser[i] >= 10000) {
              sscanf(&iline[87], "%20c", altnames[i]);
              sscanf(&iline[114], "%f", &gr_alt[i]);
/*              printf(" near: %20s   %6.1f\n", altnames[i], gr_alt[i]);
*/
           } /* else printf("\n"); */
               
           if (g_ser[i] > ucases) ucases = g_ser[i];
/*           printf("Reading old catalog: : %4d, ra[i]: %8.3f\n", i, ra[i]);
*/
        }
        
sum_end:
        fclose(in);
firstsum:
/*        for (ijk=0; ijk<imax; ijk++) printf(" %7.3f", ra[ijk]);
        printf("\n");
*/        
   	ucases -= 10000;
   	printf("Combining lists, new cases: %d, existing list content: %d, ucases: %d\n", cases, imax, ucases);
        if (cases == 0) return; 

        for (jj=0; jj<cases; jj++) {	/* loop over new events and update summary list of detected sources */
           
           old = 0;			/* initially, assume this source has not been identified before */
           if (imax > 0) {
              for (i=0; i<imax; i++) {
                 if ((p_ser[jj] < 10000) && (p_ser[jj] == g_ser[i])) {
                    gn_src[i] += 999 + n_src[jj];
                    g_SN[i] += p_wgt[jj];
                    old = 1;
                 }
                 if ((p_ser[jj] >= 10000) && (g_ser[i] >= 10000)) {	
                    /* two unidentified sources may be the same */
                    if ((fabs(ra[i] - p_ra[jj]) * cos(decl[i] / rad2g) < p_limit * 1.41) 
                         && (fabs(decl[i] - p_dec[jj]) < p_limit * 1.41)) {
                       gn_src[i] += 999 + n_src[jj];
                       ra[i] = (p_ra[jj] * p_wgt[jj] + ra[i] * g_SN[i]);
                       decl[i] = (p_dec[jj] * p_wgt[jj] + decl[i] * g_SN[i]);
                       g_SN[i] += p_wgt[jj];
                       ra[i] /= g_SN[i];
                       decl[i] /= g_SN[i];
                       old = 1;
                    }
                 }

              }
           }   

           if (old == 0) {
/*              printf("old = 0, jj: %3d\n", jj);
*/              
              gn_src[imax] = n_src[jj];
              g_SN[imax] = p_wgt[jj];
              g_ser[imax] = p_ser[jj];
              ra[imax] = p_ra[jj];
              decl[imax] =  p_dec[jj];
              strcpy(srcnames[imax], p_name[jj]);
              if (p_ser[jj] >= 10000) {
                 ucases++;
/*                 sprintf(srcnames[imax], "    Unidentified%03d ", ucases);
*/
                 sprintf(altnames[imax], "%20s", catnames[pn_alt[jj]]);
                 gr_alt[imax] = pr_alt[jj];
                 g_ser[imax] = 10000 + ucases;
              }
              
              imax++;
           }
        }


        in = fopen("allsources.idt","wt") ;
	if ( in == NULL) 
	{
	  printf("Error opening summary file: ..... exiting!\n") ;
	  return ;
	}

        printf("New summary output, %3d sources\n", imax);
        fprintf(in, "%5d\n", imax);
        
/*        gnufil = fopen("results.gnu","wt") ;
	if ( gnufil == NULL)
	{
	  printf("Error opening summary gnufile: ..... exiting!\n") ;
	  return ;
	}
*/
/*        for (i=0; i<imax; i++) 
           printf("i: %4d, ra[i]: %8.3f\n", i, ra[i]);
*/           
        sortmin(ra, imax, oa);
/*        for (i=0; i<imax; i++) 
           printf("i: %4d, oa[i]: %4d, ra[i]: %8.3f, ra[oa[i]]: %8.3f\n", i, oa[i], ra[i], ra[oa[i]]);
*/        
        k = 0;
        for (i=0; i<imax; i++) {
           g_SN[oa[i]] = sqrt((double)(g_SN[oa[i]]));
           if (g_ser[oa[i]] < 10000) {

              sprintf(goodnames[k] ,"%20s", srcnames[oa[i]]);
              goodra[k] = ra[oa[i]];
              gooddec[k] = decl[oa[i]];
              
/*              fprintf(gnufil, "%+7.3f %+7.3f\n", ra[oa[i]], decl[oa[i]]);
*/
              fprintf(in, "1 %3d  %20s  %8.3f  %+7.3f   %6d  %8.3f  %6d\n", 
                 k+1, srcnames[oa[i]], ra[oa[i]], decl[oa[i]], gn_src[oa[i]], g_SN[oa[i]], g_ser[oa[i]]);
/*              printf("%3d  %s  RA/dec: %8.3f  %+7.3f  cases:  %6d   SN: %8.3f  %6d\n", 
                 k, srcnames[oa[i]], ra[oa[i]], decl[oa[i]], gn_src[oa[i]], g_SN[oa[i]], g_ser[oa[i]]);
*/
              k++;
           }
        }
/*        fprintf(gnufil, "\n\n");
*/
/*        fprintf(in, "\n");
*/

        for (i=0; i<imax; i++) {
           if (g_ser[i] >= 10000) {
              n = near(goodra, gooddec, k, 0.0001, ra[i], decl[i], &k2min, &r2min);
              sprintf(altnames[i], "%20s", goodnames[k2min]);
              gr_alt[i] = r2min;
              f_ser[i] = charsum(altnames[i], 20);

           }
        }
        
        sortmin(f_ser, imax, oa);
        k = 1;
        for (i=0; i<imax; i++) {
           if ((g_ser[oa[i]] >= 10000) && (gn_src[oa[i]] >= 1000) && (gr_alt[oa[i]] >= 10.0)) {
/*              fprintf(gnufil, "%+7.3f %+7.3f\n", ra[oa[i]], decl[oa[i]]);
*/
              fprintf(in, "2 %3d  %20s  %8.3f  %+7.3f   %6d  %8.3f  %6d        near: %20s  sep: %4.1f\n", 
                 k, srcnames[oa[i]], ra[oa[i]], decl[oa[i]], gn_src[oa[i]], g_SN[oa[i]], g_ser[oa[i]],
                 altnames[oa[i]], gr_alt[oa[i]]);
/*              printf("%3d  %s  RA/dec: %8.3f  %+7.3f  cases:  %6d   SN: %8.3f  %6d\n", 
                 k, srcnames[oa[i]], ra[oa[i]], decl[oa[i]], gn_src[oa[i]], g_SN[oa[i]], g_ser[oa[i]]);
*/
              k++;
           }
        }
        for (i=0; i<imax; i++) {
           if ((g_ser[oa[i]] >= 10000) && (gn_src[oa[i]] >= 1000) && (gr_alt[oa[i]] < 10.0)) {
/*              fprintf(gnufil, "%+7.3f %+7.3f\n", ra[oa[i]], decl[oa[i]]);
*/
              fprintf(in, "3 %3d  %20s  %8.3f  %+7.3f   %6d  %8.3f  %6d        near: %20s  sep: %4.1f\n", 
                 k, srcnames[oa[i]], ra[oa[i]], decl[oa[i]], gn_src[oa[i]], g_SN[oa[i]], g_ser[oa[i]],
                 altnames[oa[i]], gr_alt[oa[i]]);
/*              printf("%3d  %s  RA/dec: %8.3f  %+7.3f  cases:  %6d   SN: %8.3f  %6d\n", 
                 k, srcnames[oa[i]], ra[oa[i]], decl[oa[i]], gn_src[oa[i]], g_SN[oa[i]], g_ser[oa[i]]);
*/
              k++;
           }
        }
/*        fprintf(gnufil, "\n\n");
*/
/*        fprintf(in, "\n");
*/
/*        sortmax(g_SN, imax, oa);
*/
        k = 1;
        for (i=0; i<imax; i++) {
           if (g_ser[oa[i]] >= 10000) 
              if ((g_SN[oa[i]] >= 5.0) && (gn_src[oa[i]] < 1000) && (gr_alt[oa[i]] >= 10.0)) {
/*                 fprintf(gnufil, "%+7.3f %+7.3f\n", ra[oa[i]], decl[oa[i]]);
*/
                 fprintf(in, "4 %3d  %20s  %8.3f  %+7.3f   %6d  %8.3f  %6d        near: %20s  sep: %4.1f\n", 
                    k, srcnames[oa[i]], ra[oa[i]], decl[oa[i]], gn_src[oa[i]], g_SN[oa[i]], g_ser[oa[i]],
                    altnames[oa[i]], gr_alt[oa[i]]);
/*                 printf("%3d  %s  RA/dec: %8.3f  %+7.3f  cases:  %6d   SN: %8.3f  %6d\n", 
                    k, srcnames[oa[i]], ra[oa[i]], decl[oa[i]], gn_src[oa[i]], g_SN[oa[i]], g_ser[oa[i]]);
*/
                 k++;
              }
        }
        for (i=0; i<imax; i++) {
           if (g_ser[oa[i]] >= 10000) 
              if ((g_SN[oa[i]] >= 5.0) && (gn_src[oa[i]] < 1000) && (gr_alt[oa[i]] < 10.0)) {
/*                 fprintf(gnufil, "%+7.3f %+7.3f\n", ra[oa[i]], decl[oa[i]]);
*/
                 fprintf(in, "5 %3d  %20s  %8.3f  %+7.3f   %6d  %8.3f  %6d        near: %20s  sep: %4.1f\n", 
                    k, srcnames[oa[i]], ra[oa[i]], decl[oa[i]], gn_src[oa[i]], g_SN[oa[i]], g_ser[oa[i]],
                    altnames[oa[i]], gr_alt[oa[i]]);
/*                 printf("%3d  %s  RA/dec: %8.3f  %+7.3f  cases:  %6d   SN: %8.3f  %6d\n", 
                    k, srcnames[oa[i]], ra[oa[i]], decl[oa[i]], gn_src[oa[i]], g_SN[oa[i]], g_ser[oa[i]]);
*/
                 k++;
              }
        }
/*        fprintf(gnufil, "\n\n");
*/
/*        fprintf(in, "\n");
*/
        k = 1;
        for (i=0; i<imax; i++) {
           if (g_ser[oa[i]] >= 10000) 
              if ((g_SN[oa[i]] < 5.0) && (gn_src[oa[i]] < 1000) && (gr_alt[oa[i]] >= 10.0)) {
/*                 fprintf(gnufil, "%+7.3f %+7.3f\n", ra[oa[i]], decl[oa[i]]);
*/
                 fprintf(in, "6 %3d  %20s  %8.3f  %+7.3f   %6d  %8.3f  %6d        near: %20s  sep: %4.1f\n", 
                    k, srcnames[oa[i]], ra[oa[i]], decl[oa[i]], gn_src[oa[i]], g_SN[oa[i]], g_ser[oa[i]],
                    altnames[oa[i]], gr_alt[oa[i]]);
                 k++;
              }
        }
        for (i=0; i<imax; i++) {
           if (g_ser[oa[i]] >= 10000) 
              if ((g_SN[oa[i]] < 5.0) && (gn_src[oa[i]] < 1000) && (gr_alt[oa[i]] < 10.0)) {
/*                 fprintf(gnufil, "%+7.3f %+7.3f\n", ra[oa[i]], decl[oa[i]]);
*/
                 fprintf(in, "7 %3d  %20s  %8.3f  %+7.3f   %6d  %8.3f  %6d        near: %20s  sep: %4.1f\n", 
                    k, srcnames[oa[i]], ra[oa[i]], decl[oa[i]], gn_src[oa[i]], g_SN[oa[i]], g_ser[oa[i]],
                    altnames[oa[i]], gr_alt[oa[i]]);
                 k++;
              }
        }
/*        fprintf(gnufil, "\n\n");
*/
        fclose(in);
/*        fclose(gnufil);
*/
        printf("Initial and final catalog length: %7d, %7d\n", jjgst, jjg);
        fclose(cat);

}

/* **************************************************************** */

void sortmin(float ia[], int N, int oa[])
{
   int i, j, k, minj;
   float temp, min;
   
   for (i=0; i<N; i++) oa[i] = -1;
   j = -1;

next:
   j++;
   for (i=0; i<N; i++) {
      for (k=0; k<N; k++) if (oa[k] == i) goto nexti;

      min = ia[i];
      minj = j;
      oa[j] = i;
      goto next2;
      
nexti: ;
   }
   return;
   
next2:
/*   printf("%3d minj: %3d, min %8.3f\n", j, minj, min); 
   for (i=0; i<N; i++) printf(" %+3d", oa[i]);
*/   
   for (i=0; i<N; i++) {
      for (k=0; k<N; k++) if (oa[k] == i) goto nexti2;

      if (ia[i] < min) {
         oa[minj] = -1;
         min = ia[i];
         minj = j;
         oa[j] = i;
      }
nexti2: ;
   }
/*   printf("\n");
   for (i=0; i<N; i++) printf(" %+3d", oa[i]);
   printf("\n%3d minj: %3d, min %8.3f\n\n", j, minj, min); 
*/
   goto next;
}


/* **************************************************************** */

void sortmax(float ia[], int N, int oa[])
{
   int i, j, k, maxj;
   float temp, max;
   
   for (i=0; i<N; i++) oa[i] = -1;
   j = -1;

next:
   j++;
   for (i=0; i<N; i++) {
      for (k=0; k<N; k++) if (oa[k] == i) goto nexti;

      max = ia[i];
      maxj = j;
      oa[j] = i;
      goto next2;
      
nexti: ;
   }
   return;
   
next2:
/*   printf("%3d maxj: %3d, max %8.3f\n", j, maxj, max); 
   for (i=0; i<N; i++) printf(" %+3d", oa[i]);
*/   
   for (i=0; i<N; i++) {
      for (k=0; k<N; k++) if (oa[k] == i) goto nexti2;

      if (ia[i] > max) {
         oa[maxj] = -1;
         max = ia[i];
         maxj = j;
         oa[j] = i;
      }
nexti2: ;
   }
/*   printf("\n");
   for (i=0; i<N; i++) printf(" %+3d", oa[i]);
   printf("\n%3d maxj: %3d, max %8.3f\n\n", j, maxj, max); 
*/
   goto next;
}

/* **************************************************************** */

int near(float racat[], float decat[], int snum, float dlim, float ra, float dec, int *k2min, float *curmin2)
{
   double radif, decdif;
   float rdif, curmin;
   int k, kmin, nmin=0;
         
   curmin = *curmin2 = 180.0;
   kmin = *k2min = -1; 
   for (k=0; k<snum; k++) { 		/* search for match with catalog source */
      decdif = decat[k] - dec;
      radif = (racat[k] - ra) * cos(decat[k] / rad2g);
      rdif = sqrt(radif*radif + decdif*decdif);
      
      if (rdif < curmin) {
         *curmin2 = curmin;
         *k2min = kmin;
         curmin = rdif;
         kmin = k;
         nmin++;
      } else {
         if (rdif < *curmin2) {
            *curmin2 = rdif;
            *k2min = k;
         }
      }
   }
   
   if (curmin < dlim) {		/* match found ! */ 
      return(kmin);
   } else {
      *k2min = kmin;
      *curmin2 = curmin * 60.0;
      return(-1);
   }

}

/* **************************************************************** */

float charsum(char name[], int n)
{
   float sum = 0.0;
   int i;
   
   for (i=0; i<n; i++) sum = sum * 1.14159 + (float)(name[i]); 

   return(sum);
}

/* **************************************************************** */

void gengnu(char *datnavn, int orbit, int T_bin)
{
  FILE *df;
  char gnunavn[200];
  int ee;
   
  for (ee=0; ee<4; ee++) {
   sprintf(gnunavn, "gnu_%s_%03d_E%1d", datnavn, orbit, ee);
   df = fopen(gnunavn, "wt");
   fprintf(df, "set title \"%s light curve, orbit %3d, time_bin: %d s\"\n", datnavn, orbit, T_bin);
   fprintf(df, "set xlabel \"Time (offset: 52564.1 days)\"\n");
   fprintf(df, "set ylabel \"Count rate cts/s per 100 cm2\"\n");
   fprintf(df, "set y2range [0:120]\n");
   fprintf(df, "#set yrange [-1:5]\n");
   fprintf(df, "set y2tics \n");
   fprintf(df, "plot \"lci_%1d.gnu\" index 0 axes x1y1 title \"<- 5-10 keV light curve\" with errorbars\n", ee);
   fprintf(df, "replot \"lc8_1.gnu\" index 0 axes x1y2 title \"Illum. area cm2 ->\" with points ps 2\n");
   fprintf(df, "replot \"lc4_%1d.gnu\" index 0 axes x1y1 title \"<- 5-10 keV raw light curve\" with points\n", ee);
   fprintf(df, "replot \"lcc_1.gnu\" index 0 axes x1y2 title \"pid / 10 ->\" with points\n"); 
   fprintf(df, "replot \"lcd_1.gnu\" index 0 axes x1y2 title \"pid % 10 ->\" with points\n"); 
   fprintf(df, "replot \"lcb_1.gnu\" index 0 axes x1y1 title \"Zero\" with steps\n"); 
   fprintf(df, "#replot \"lc3.gnu\" index 0 axes x1y2 title \"Livetime/point(s) ->\" with steps lt 4 lw 2\n");
   fprintf(df, "set terminal postscript color\n");
   fprintf(df, "set output \"gnu_%s_%03d_E%1d.ps\"\n", datnavn, orbit, ee);
   fprintf(df, "replot\n");
   fclose(df);
  }
}


