
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/timeb.h>

#include "midi_b.h"

char progres[5] = {'F','i', 'b', ' ', '.'};

/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/*                                                             */
/*  Niels Lund, February 2003                                  */        
/*                                                             */        
/*                                                             */
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

float fun(int k, int ii, int ee, float srcx[], float srcy[], int jemx, float norm_d[], int last)
{
   static int src_list[sourcmax] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
   int i, j, n, ki, length, bytes, det_index, word, bitval, track_len, sxy, nn, mapdist[10];
   int ix, iy, mmpix, maxpix;
   char backmap[detdim], srcfilname[40];
   static unsigned char detmap[sourcmax][detdim], odetmap[detdim];
   static char initmap[detdim];
   static unsigned char sfmap[4][detdim];
   static float src_maps[sourcmax][detdim], cnt=0;
   static float s_x[sourcmax], s_y[sourcmax], srcsum[4], max_vals[4], pix_cnt[4];
   float val, hdr_inf[4], max, lysfrac, sum2;
   int comb_delta[500], track_delta[100], comb_len;
   int kt_max[4][4], det_step[4][4][16];
   float comb_list[500], track_list[100], sum, src_xy[4];
   FILE *funout;
   
   if (ii == 0) goto backgr_evaluate;
   
   if (k < 0) {
      for (i=0; i<sourcmax; i++) {
         src_list[i] = 0;
         norm_d[i] = 1.0;
      }
      
      return(0.0);
   }
   
   if (soft_gr[ii] < 0.0) return(0.0);
      
   if (k == 0) return(1.0 / (float)(soft_tot[26+ee]));

   if (k == 1) return(soft_gr[ii]);
   
   if (k < 20) {
      if ((src_list[k] == k) && (srcx[k] == s_x[k]) && (srcy[k] == s_y[k])) goto evaluate;

/*      printf("src_list: %6d %6d %6d %6d %6d %6d\n", src_list[0], src_list[1], src_list[2], src_list[3]
      		, src_list[4], src_list[5]);
*/
      src_list[k] = k;
      s_x[k] = srcx[k];
      s_y[k] = srcy[k];
      sxy = (int)(srcx[k]) * sky_ydim + (int)(srcy[k]);
      
/*      printf("\nFirst function call (k=%2d, sxy=%5d, jmx=%1d) with new source position: %6.2f, %6.2f, last %1d\n", 
            k, sxy, jemx+1, srcx[k], srcy[k], last);
*/
      norm_d[k] = detecmap(srcx[k], srcy[k], &detmap[k][0], 0, jemx);	

      if (norm_d[k] < 0.0) {
         printf("No data for sky_index %05d\n", sxy);
         return(0);
      }  
      
         /* calculate detector illumination from (fractional) source position */
         /* detmap contains 2 in illuminated detector pixels, and 1 in area onto which mask pattern is projected */
      track_len =  sh_depth(absolen, sxy, track_list, track_delta);
         /* calculate distribution of X-ray absorbtion points relative to entry point at window level */
         /* track_list contains fraction of (1) photon arriving at detector pixels specified in track_delta */ 
      sum = 0.0;
      for (i=0; i<track_len; i++) sum += track_list[i];

/*      printf("Sum of %3d contributions along track %7.4f at energy %1d\n", track_len, sum, ee);
*/
      comb_len = shapecomb(scatt_list, scatt_delta, scatt_len, 
    			track_list, track_delta, track_len, comb_list, comb_delta);
         /* calculate combined effect of X-ray penetration into detector and position uncertainty of MS read-out */
         /* comb_list contains fraction of (1) photon arriving at detector pixels specified in comb_delta */                  sum = 0.0;
      for (i=0; i<comb_len; i++) sum += comb_list[i];

/*      printf("Sum of %3d contributions around point %7.4f at energy %1d\n", comb_len, sum, ee);
*/    
      pix_cnt[ee] = shapefold(&detmap[k][0], comb_list, comb_delta, comb_len, &src_maps[k][0], last);
      /* src_maps[k][] contains for each detector pixel the calculated fraction of 1 photon arriving from source k*/
      
      sum2 = 0.0;
      lysfrac = 0.0;
      maxpix = 0;
      for (i=1; i<detdim; i++) {
         sum2 += src_maps[k][i];
         if (soft_gr[i] <= 0.0) src_maps[k][i] = 0.0;
         if (src_maps[k][i] > lysfrac) {
            lysfrac = src_maps[k][i];
            maxpix = i;
         }
      }
      
      nn = 0;
      for (i=1; i<detdim; i++) {
         src_maps[k][i] /= sum2;
         if (detmap[k][i] > 1) nn++;
      }
   

      if (last) {
         n = nn = 0;
         j = 1<<ee;
         max = 0.0;
         mmpix = 0;
         srcsum[ee] = 0.0;
         
         for (i=0; i<detdim; i++) {

            if (ee == 0) {
               initmap[i] = 0; 
               odetmap[i] = 0;
            }
            if ((soft_gr[i] >= 0.0) && (detmap[k][i] > 0)) {
               n++;		/* count pixels in mask projected area */
               initmap[i] |= j;
               srcsum[ee] += src_maps[k][i];
            }

            odetmap[i] += detmap[k][i] * j * j;

            if (detmap[k][i] > 1) nn++;
            
            if (src_maps[k][i] > max) {
               max = src_maps[k][i];
               mmpix = i;
            }
         }
         for (i=0; i<detdim; i++) {
            sfmap[ee][i] = src_maps[k][i] * 250.0 / max;
         }
         max_vals[ee] = 250.0 / lysfrac;

         printf(
"Illum_pix (E%1d): %6.0f %6d %7.1f, Recvd: %6.3f, msk prj area: %6d, norm: %10.5f, best pix; %6d/%6d, %7.5f \n",
            ee, (float)(1.0/norm_d[k]), nn, pix_cnt[ee], srcsum[ee], n, max, mmpix, maxpix, lysfrac);
      }

      /* output final source pattern for source extraction - in the future source extraction should 
         calculate the source model itself */

      if ((last > 0) && (ee == 3) && (o_ctrl > 0)) {
         src_xy[0] = srcx[k];
         src_xy[1] = srcy[k];


         n = k-backmodels;
         sprintf(srcfilname, "src_patt_%03d_%03d_%1d.pat", aux_orbit, aux_pid, jemx+1);
         funout = fopen(srcfilname, "wb");

         hdr_inf[0] = 1.0;
         hdr_inf[1] = com_RA[n];
         hdr_inf[2] = com_dec[n];         
         hdr_inf[3] = n;
         
         fwrite(hdr_inf, 4, 4, funout);
         fwrite(srcsum, 4, 4, funout);
         fwrite(pix_cnt, 4, 4, funout);
         fwrite(max_vals, 4, 4, funout);
         fwrite(odetmap, detdim, 1, funout);

         fwrite(initmap, detdim, 1, funout);

         fwrite(sfmap, 4*detdim, 1, funout);

         fwrite(src_xy, 4, 4, funout);
         fclose(funout);
            
      }

  }

evaluate:
   if (norm_d[k] < 0.0) return(0.0);
   if (soft_gr[ii] >= 0.0) return(src_maps[k][ii]);
   return(0.0);

backgr_evaluate:
   if (norm_d[k] < 0.0) return(0.0);
   for (i=0; i<detdim; i++) backmap[i] = 0;

   n = 0;
   for (i=0; i<detdim; i++) {
      if ((detmap[k][i] > 0.0) && (soft_gr[i] >= 0.0)) {
         n++;
         ki = i + 771;			/* pick four points around illuminated pixel (3+3 pixels away) */
         if ((ki >= 0) && (ki < detdim)) backmap[ki] = 1;
         ki = i - 771;
         if ((ki >= 0) && (ki < detdim)) backmap[ki] = 1;
         ki = i + 765;
         if ((ki >= 0) && (ki < detdim)) backmap[ki] = 1;
         ki = i - 765;
         if ((ki >= 0) && (ki < detdim)) backmap[ki] = 1;
      }
   }
   sum = 0.0;
   ki = 0;
   for (i=0; i<detdim; i++) {
      if (backmap[i] > 0) {
         ki++;
         if (soft_gr[i] >= 0.0) sum += shadow[i];
      }
   }
    
   sum *= (float)(n) / ((float)(ki) + 0.0001) ; /* background count corresponding to the illuminated pixels */
/*   printf(
      "Fun: Source %2d at energy: %1d, no. of illum. pixels: %5d, no of backgr. pixels: %6d, norm_d; %10.6f\n", 
      k, ee, n, ki, norm_d[k]);
*/
   return(sum);
}

/* ************************************************************************** */

double backpro_d(float shdgr[detdim], float sky[skydim])
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/*                                                             */        
/*                                                             */        
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

/* subroutine to backproject a JEM-X shadowgram as provided in shdgr[detdim] */

{
   int det_index, length=0, sky_index, skystep, i, j, odd;
   double e_sum = 0.0;
   unsigned char  *byt_index, *byt_bot, *byt_top;
   
   putchar(progres[2]);

   for (i=0; i<skydim; i++) sky[i] = 0.0;
   
      j = 0;
      e_sum = 0.0;
      for (i=0; i<detdim; i++) {
         if (soft_gr[i] > 0.0) {
            j++;
            e_sum += shdgr[i];
         } else shdgr[i] = 0.0;
      }

   for (det_index=0; det_index<detdim; det_index++) {

      if (shdgr[det_index] == 0.0) continue;
      
      length = d_allow_l[det_index];
      
      if (length == 0) continue;
            
      sky_index = d_allow_p[det_index];
      
      sky[sky_index] += shdgr[det_index];
      
      if (length == 1) continue;

      byt_bot = d_allow + d_allow_st[det_index];
      byt_top = byt_bot + length - 1;

      i = 0;
      for (byt_index=byt_bot; byt_index<byt_top; byt_index++) {
         skystep = (int)(*byt_index);
         sky_index += skystep;
         if (skystep <  255) sky[sky_index] += shdgr[det_index];
         
      }
   }

   return(e_sum);
}

/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/*                                                             */
/*  Niels Lund, February 2003                                  */        
/*                                                             */
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

int findpeak(float *sky, char *access, int smaxx[], int smaxy[], double amax[], float edge) 

/*  Search the highest point in the backprojected sky image.
    The <access> array defines the field of view. Only the 
    maximum peak will be identified and its position will be 
    returned in <smaxx[0]> and <smaxy[0]>.
*/ 

{
      int i, j, k, jj, m, n, f, sky_index, indent = 6, m0=0, skymax, sxy_m, sxy_p;
      int remov[max_candidates+1], xsky, k_y, k_x, k_m, k_p; 
      double aval, blocal, m1=0.0, m2=0.0, mean, var, rms, excess, level, d_y, d_x;
      
      blocal = -10000.0;

      for (i=0; i<skydim; i++) {	/* partially compensate for decrease in illumination at edge of FOV */
         if (det_e[i] > signiflim) {
            if (edge != 0.0) sky[i] *= edge * rsignif[i];
         } else {
            sky[i] = 0.0;
         }
      }
   	
      jj = k = 0;
      skymax = -1;
      for (j=0; j<sky_xdim; j++) {
          for (i=0; i<sky_ydim; i++) {
              sky_index = jj + i;
              if (access[sky_index] > 0) { 
                  aval = sky[sky_index];
                  m0++;
                  m1 += aval;
                  m2 += aval * aval;
                  if (aval >= blocal) {
                      smaxy[k] = i;
                      smaxx[k] = j;
                      amax[k] = aval;
                      blocal = aval;
                      skymax = sky_index;
                  }
              }
          }
          jj += sky_ydim;
      }
      
      if ((skymax < 766) || (skymax > (skydim-767))) return(-1);
      if (m2 == 0.0) return(-1);
      if (m0 == 0) return(-1);
      
      /* calculate peak excess, and peak centroid */

      mean = m1 / m0;
      var = m2/m0 - mean * mean;
      rms = sqrt(var);
      amax[max_candidates] = rms;

      excess = blocal;
      level = sky[skymax+3] + sky[skymax-3] + sky[skymax+765] + sky[skymax-765];
      level += sky[skymax+3+255] + sky[skymax-3+255] + sky[skymax+765+1] + sky[skymax-765+1];
      level += sky[skymax+3-255] + sky[skymax-3-255] + sky[skymax+765-1] + sky[skymax-765-1];
      level /= 6.0;
      
      sxy_p = skymax + 1;
      sxy_m = skymax - 1;
      if (sky[sxy_p] > sky[sxy_m]) {
         smaxy[1] = 1;
         excess += sky[sxy_p];
         k_y = 1;
         d_y = (sky[skymax] - sky[sxy_p]) / (sky[skymax] + sky[sxy_p] - level); 
      } else {
         smaxy[1] = -1;
         excess += sky[sxy_m];
         k_y = -1;
         d_y = (sky[sxy_m] - sky[skymax]) / (sky[skymax] + sky[sxy_m] - level);
      }

      sxy_p = skymax + 255;
      sxy_m = skymax - 255;
      if (sky[sxy_p] > sky[sxy_m]) {
         smaxx[1] = +255;
         excess += sky[sxy_p];
         k_x = 255;
         d_x = (sky[skymax] - sky[sxy_p]) / (sky[skymax] + sky[sxy_p] - level);
      } else {
         smaxx[1] = -255;
         excess += sky[sxy_m];
         k_x = -255;
         d_x = (sky[sxy_m] - sky[skymax]) / (sky[skymax] + sky[sxy_m] - level);
      }
         
      excess += sky[skymax+k_y+k_x];
      excess -= level + level;
      level /= 2.0;
      amax[3] = excess;
      amax[1] = smaxx[0] + d_x;
      amax[2] = smaxy[0] + d_y;
      amax[4] = level;
      amax[5] = rms;
         
/*  printf("Findpeak: skymax: %5d, 4pt-excess: %6.1lf, level: %6.1lf, skymap rms: %8.2lf,  XY: %5.1lf, %5.1lf\n",
            skymax, amax[3], amax[4], amax[5], amax[1], amax[2]);
*/
  return(skymax); 
}

/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

/***************************************************************/
/*                                                             */
/*  Niels Lund, February 2003                                  */        
/*                                                             */
/***************************************************************/

double imagefit(float shdg[], int jemx, int ee, float resid[], int n_source, float srcx[], float srcy[], 
                double *solut, float norm_d[], float sumfun[], int last)
{
   int i, j, k, n, k1, k2, status, loclast;
   static double mean, var, m0, m1, m2, rms;
   double mm0, mm1, mm2, mmean, mvar, mrms, r, r2, x, y;
   double coeffs[sourcmax * sourcmax], rhs[sourcmax], obs2, fun_k1;
   double coeff2[sourcmax * sourcmax], rhs2[sourcmax], rsum[27]; 
   float checkval;
   
   putchar(progres[1]);

   m0 = m1 = m2 = var = 0.0;
   
   if (n_source <= backmodels) {
      for (i=0; i<detdim; i++) {
         if (soft_gr[i] <= 0.0) continue;	/* all pixels to be rejected are <=0 in soft_gr[i] */
         m0++;
         m1 += shdg[i];
         m2 += shdg[i] * shdg[i];
      }
      mean = m1 / m0;
      var = m2/m0 - mean * mean;
      rms = sqrt(var);

/*      printf("\nJEM-X%1d, E=%1d, events: %10.0lf, active pixels: %7.0lf, counts/pixel: %7.1lf, rms: %7.2lf\n",
         jemx+1, ee, m1, m0, mean, rms);
*/
   }
   
   /* collect data */
   
   if (n_source > backmodels) {
      for (i=backmodels; i<n_source; i++) {
         loclast = 0;
         if ((last == 1) && (i == backmodels)) loclast = last;
         if ((last > 1) && (i == last)) loclast = last;
         fun(i, detdim/2, ee, srcx, srcy, jemx, norm_d, loclast);	/* initialize source functions */
         sumfun[i] = 0.0;
         for (j=1; j<detdim; j++) if (soft_gr[j] > 0.0) sumfun[i] += fun(i, j, ee, srcx, srcy, jemx, norm_d, 0);
      }
   }
   
   /* n_source = backmodels (currently: 2) means:  constant + background model matching energy band */

   for (k1=0; k1<n_source; k1++) {
      rhs[k1] = 0.0;
      for (k2=0; k2<n_source; k2++) coeffs[k1*n_source+k2] = 0.0;
   }
   
   for (i=1; i<detdim; i++) {
      if (soft_gr[i] < 0.0) continue;	/* all pixels to be rejected are <0 in soft_gr */
      for (k1=0; k1<n_source; k1++) {
         fun_k1 = fun(k1, i, ee, srcx, srcy, jemx, norm_d, 0);
         rhs[k1] += fun_k1 * shdg[i];
         for (k2=k1; k2<n_source; k2++) 
            coeffs[k1 + n_source*k2] += fun_k1 * fun(k2, i, ee, srcx, srcy, jemx, norm_d, 0);
      }
   }
   
/*   printf("Function sums: ");
*/
   for (k1=0; k1<n_source; k1++) {
      rhs2[k1] = rhs[k1];
      for (k2=k1; k2<n_source; k2++) {
         coeffs[k2+n_source*k1] = coeff2[k1+n_source*k2] = coeff2[k2+n_source*k1] = coeffs[k1+n_source*k2];
      }
   }
/*   printf("\n");
*/    
   for (k1=0; k1<n_source; k1++) {
      for (k2=0; k2<n_source; k2++) {
         if (rhs[k1] == 0.0) printf(" %8.1lf", coeffs[k1*n_source+k2]);

      }
      if (rhs[k1] == 0.0) printf("   %8.1lf  Source %2d is suspicious!\n", rhs[k1], k1);
   }
   
   /* solve the equation system */
   status = gaussj_nr(coeffs, n_source, rhs, 1);
   if (status < 0) {
      printf("Sing. matrix w. %d comp: %2d", n_source, status); 
      return(status);
   }
   
   for (k1=0; k1<n_source; k1++) solut[k1] = rhs[k1];

   resid[0] = 0.0;
   for (i=1; i<detdim; i++) {
      resid[i] = 0.0;
      if (soft_gr[i] < 0.0) continue;	/* all pixels to be rejected have < in soft_gr */
      resid[i] = shdg[i];      
      for (k1=0; k1<n_source; k1++) {
         resid[i] -= solut[k1] * fun(k1, i, ee, srcx, srcy, jemx, norm_d, 0);
      }
   }
   
/*   printf("\n");
*/
   for (k1=0; k1<n_source; k1++) {
      for (k2=0; k2<n_source; k2++) {
         /* printf(" %8.1lf", coeffs[k1*n_source+k2]); */
      }
  
/*      if (k1 == 0) printf("grp: %2d,  Constant term,      strength:  %+10.1lf \n", k1, solut[k1]);
      if (k1 == 1) printf("grp: %2d,  Background model,   strength:  %+10.1lf \n", k1, solut[k1]);
      if (k1 >= backmodels) 
         printf("Imagefit: grp: %2d,  XY: %6.1f/%6.1f,  strength:  %+10.1lf \n", k1, srcx[k1], srcy[k1], solut[k1]);
*/
   }
   
   mm0 = mm1 = mm2 = mvar = 0.0;

   for (i=0; i<detdim; i++) {
      if (soft_gr[i] < 0.0) continue;	/* all pixels to be rejected are <0 in soft_gr[i] */
      mm0++;
      mm1 += resid[i];
      mm2 += resid[i] * resid[i];
   }
   mmean = mm1 / mm0;
   mvar = mm2/mm0 - mmean * mmean;

   if (mvar < 0.0) {printf("Negative variance after fit: %10.1lf\n", mvar); return(-1);}
/*   mrms = sqrt(mvar);   */
   mrms = mvar;

/*   printf("JEM-X%1d, E=%1d, after fitting with %2d components.  variance: %7.4lf\n", 
      jemx+1, ee, n_source, mrms);
*/
   return(mrms);
}

/* **************************************************************** */

/* **************************************************************** */

int gaussj_nr(double a[], int n, double b[], int m)

/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/*                                                             */
/*  Niels Lund, February 2003                                  */        
/*                                                             */
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

/* -------------------------------------------------------------

docbegin:

*  Name of source file:
*         /home/nl/jemx/ipfread/jemx1-2/sky/gaussj_nr.c

*  Version of source file:      0.00
*  Parent component:            gaussj_nr from NJW 
*  Programmer:                  Niels Lund (modification to avoid DAL/PIL/RIL dependencies)
*  Affiliation:                 Danish Space Research Institute
*  Purpose:                     Fit of shadowgram components for Iterative Removal of Sources
*  Origin date:                 021220
*  Update history:
*  Type of element:             Function
*  Part of package:             minisky.c
*  Required functions		SWAP
Various remarks:

Gauss-Jordan matrix inversion from "Numerical Recipes"
adapted to follow the storage convention:		    a(i,j) = a[j*Ni + i]

-------------------------------------------------------------- */
{
   int icol, irow, i, j, k, l, ll;
   int indxc[20], indxr[20], ipiv[20];
   double big, dum, pivinv;

   for (j=0;j<n;j++) ipiv[j]=0;
   for (i=0;i<n;i++) {
      big=0.0;
      for (j=0;j<n;j++)
         if (ipiv[j] != 1)
            for (k=0;k<n;k++) {
               if (ipiv[k] == 0) {
                  if (fabs(a[k*n+j]) >= big) {
                     big=fabs(a[k*n+j]);
                     irow=j;
                     icol=k;
                  }
               } else if (ipiv[k] > 1) return(-1);	/* singular matrix 1 */
            }
      ++(ipiv[icol]);
      
      if (irow != icol) {
         for (l=0;l<n;l++) SWAP(a[l*n + irow],a[l*n + icol]);
         for (l=0;l<m;l++) SWAP(b[l*n + irow],b[l*n + icol]);
      }
      indxr[i]=irow;
      indxc[i]=icol;
      if (a[icol*n + icol] == 0.0) return(-2);	/* singular matrix 2 */
      
      pivinv=1.0/a[icol*n + icol];
      a[icol*n + icol]=1.0;
      for (l=0;l<n;l++) a[l*n + icol] *= pivinv;
      for (l=0;l<m;l++) b[l*n + icol] *= pivinv;
      for (ll=0;ll<n;ll++)
         if (ll != icol) {
            dum=a[icol*n + ll];
            a[icol*n + ll]=0.0;
            for (l=0;l<n;l++) a[l*n + ll] -= a[l*n + icol]*dum;
            for (l=0;l<m;l++) b[l*n + ll] -= b[l*n + icol]*dum;
         }
   }
   for (l=n-1;l>=0;l--) {
      if (indxr[l] != indxc[l])
         for (k=0;k<n;k++)
            SWAP(a[indxr[l]*n + k],a[indxc[l]*n + k]);
   }
   return(0);
}

/* **************************************************************** */

