/*
Constants, global variables and function prototypes for midi_b
 *** In all of the midi_b routines the variable "jemx" has the value 0 for JEM-X1 and 1 for JEM-X2 
*/

/* #include "/soft/saord/include/funtools.h" */

#include <funtools.h>

#define sky_xdim        255	    	/* x-dimension of skymap */
#define sky_ydim        255	    	/* y-dimension of skymap */
#define skydim      sky_xdim*sky_ydim  	/* length of (linear) skymap array */
#define skymirror	254		/* constant used for mirroring positions for JEM-X2 */

#define max_sky_bytes	200000000	/* max number of bytes in d_allow array */
#define max_candidates	20		/* max number of sky_map peak candidates accepted in search */ 
#define detdim 		65536		/* lenght of linearized detector array (256X*256Y) */
#define det_ydim	256

#define sourcmax	20		/* max number of components in shadowgram fits */
#define accumax		10000		/* max number of multiple detection source candidates */

#define SWAP(a,b) {double temp=(a);(a)=(b);(b)=temp;}	/* function used in "gaussj_nr" */

extern int d_allow_p[detdim], FOV_radius, o_ctrl;
extern short d_allow_l[detdim];
extern unsigned d_allow_st[detdim];
extern unsigned char d_allow[max_sky_bytes];
extern float soft_gr[detdim];
extern int det_e[skydim];
extern double soft_tot[30];
extern double absolen, depth_corr, accumT[2];
extern char access[skydim];
extern float rsignif[skydim];
extern float fitsimage[4][3][skydim], skyim_r[skydim], skyim[skydim];
extern double coll_r;	/* collimator radius */ 
extern double mask_r;	/* radius of coded mask pattern */
extern double mask_height;
extern double scaleX, scaleY, x2x, y2y, offX, offY, offQ, offR, phase2, xshi, yshi, indep;
extern double j_RA, j_dec;

extern char sweethome[];
extern char sweethome2[];
extern double pi, twopi, gtorad; 
extern double parameters[20];
extern int scatt_delta[500], scatt_len;
extern float shadow[detdim], scatt_list[500];
extern float com_RA[sourcmax], com_dec[sourcmax];
extern int aux_orbit, aux_pid, aux_pidv;
extern int backmodels;
extern int signiflim;


double backpro_d(float shdgr[detdim], float skyim[skydim]);
int findpeak(float *skyimage, char *access, int *smaxx, int *smaxy, double *amax, float edge);
float fturn(int jemx, float pos);
double imagefit(float shdg[], int jemx, int ee, float resid[], int n_source, 
   		float srcx[], float srcy[], double *solut, float norm_d[], float sumfun[], int last);
float fun(int k, int ii, int ee, float srcx[], float srcy[], int jemx, float norm_d[], int last);
int gaussj_nr(double *a, int n, double *b, int m);
float detecmap(float x_source, float y_source, char srcfun[detdim], int last, int jemx);
int pixelfold(short det[], int pixel_st[], unsigned char pixel_list[], float det_out[], int ee);
double rmscalc(float shad[], float soft_gr[]);
double rmscalc_i(short sh[], float soft_gr[]);
double shapefold(char det[], float comb_list[], int comb_delta[], int comb_len, float det_out[], int last);
int irosloop(float shadow[detdim], int jemx, int ee, 
   float xx[sourcmax], float yy[sourcmax], float norm_d[sourcmax], double solut[sourcmax], 
   float sumfun[sourcmax], float *goodrms, double *sh_rms2, int *goodfits, int *goodnsrc, float resid[detdim],
   float edge, float goodbet_g[sourcmax], int iterations, double limit_fraction);
int getRAdec_init(int jemx, int aux_orbit, int aux_pid, 
   	double p_RA[10000], double p_dec[10000], double p_posang[10000]);
int getRAdec(float x, float y, int jemx, float *s_RA, float *s_dec);
int getxy(float s_RA, float s_dec, int jemx, float *x, float *y);
void clean(float skyim_r[skydim], float skyim[skydim]);
void clean2(float sky_r[skydim], float xx[], float yy[], int n_common, int backmodels,  float skyim[skydim]);



