
 /*
Routine to identify science windows with pointings close to a given position or source.

July 2003 Niels Lund
*/

#include<stdio.h>
#include<math.h>
#include<stdlib.h>
#include<string.h>
#define srcnum		3500
#define NN		1000

int survey_chk(int c_orbit, int c_pid, char *sw_group, int swgnum);
void gengnu(char *datnavn, int orbit, float T_bin, double plot_offset, char *timestring, int jemx);
void gendat(char *datnavn, float RA, float dec, float T_bin, double plot_offset);

char sweethome[200], sweethome2[200];
/* ***************************************************************************** */

main(int argc, char *argv[])
{
	FILE *pofil, *cat, *gofil;
        char iname[200], iname2[100], b_file[100], iline[300], d, cdum[50], srcnames[srcnum][25];
        char p_name[100][25], pointfil[200], *target, sw_group[50], gnunavn[200], gnunavn2[200];
        char catname[200], ch, catnames[srcnum][25], dummy[200], timestring[200];

        float ra[srcnum], nH[srcnum], intens[srcnum], param1[srcnum], param2[srcnum];
        float decl[srcnum], racat[srcnum], decat[srcnum], srcRA0[5], srcdec0[5];
        int serial[srcnum], orbitfirst=0, newpid, njwmax, isdcmax, igrmax;
        int n_pid[100], p_pid, p_orbit, p_type, p_year, p_month, p_day, p_hour, p_min, p_sec, i_durat;
        int g_src[NN], n_src[NN], n, dob_orbit, t_len, pointval, s_orbit_low, s_orbit_high, n_targ, iii=0;
        
        int i, ii, j, jj, k, l, orbit, yymmdd, pid, dum, m0[4], mmm0, nn, nnn, old, unident, ucases, imax; 
        int jemx, cases, p_src[100], code, dtpe, gn_src[NN], pidv, jjg, eeval, jjgst, xtemax;
        int scwOK, group_select,ddd;

        float cosdec[2], cospos, sinpos, dist1, dist2;
        float avX, avY, s_dec, s_RA, phaX, phaY, offX, offY, offs[2], maxdist, list_RA[1000], list_dec[1000];
        float posang, dur, str1, str2, Xcenter, Ycenter, Zcenter, Xsrc, Ysrc, Zsrc, XYRsrc, srcQ, srcR;
        float avXL[NN], avYL[NN], offset, Lscale, s_wgt[NN], fitcnt, totcnt, scale, scaleX, scaleY;
        float SNmin[4], SNmax[4], ph_sign, ph_mag, dist, mmmdst, mmmdst2, mindst, mindst2, rmsdst, x2x, y2y;
        float Xcorr, Ycorr, minoffX, minoffY, minphase2, gminoffX, gminoffY, gminphase2, gminscaleX, gminscaleY;
        float p_sn[100];
        float g_ee[NN], g_x[NN], g_y[NN], g_RA[NN], g_dec[NN], g_r[NN], g_SN[NN], m_RA, m_dec, ee;
        float max_r, T_sum, T_bin;
        float p_posang, p_durat, p_IJD;

        double RA, dec, posvink, SRC_R, SRCX, SRCY, SRCZ, phas[2], meanR[4], meand[4], twopi, plot_offset;
        double rad2g, pix2rad, phas2[2], RAdif2, decdif2, mR1[4], mR2[4], md1[4], md2[4], mw0[4], mmmwgt;
        double X_target, Y_target, Z_target, tr_RA, tr_dec, p_RA, p_dec, t_RA, t_dec, j_dec, j_RA;

        sprintf(sweethome, "/nfs/r6/jemx/nlwork/midi_distribution_2/work");
	sprintf(sweethome2, "/nfs/r6/jemx/nlwork/midi_distribution_2/work/reference");

        rad2g = 180.0 / 3.14159;
        twopi = 3.14159 * 2.0;
        pix2rad = 0.05224 / rad2g;
        
        max_r = 3.0;
        t_RA = 500.0;
        t_dec = 100.0;
        t_len = 0;
        s_orbit_low = -1;
        s_orbit_high = -1;
        plot_offset = 0.0;
        group_select = 0;
        T_bin = 0.0;
        sprintf(timestring, "");
        jemx = 0;
        
        if ( argc > 3) max_r = atof(argv[1]) ;	/* search pointings within max_r(degrees) from target */
        else {           
bad_i:     
           printf("max_radius RA dec {jemx 0/1} {T_bin} {orb.lo [-1: all]} {orb.hi [-1]} ");
           printf("{plt_offset} {grp_sel [1: survey, 2: pv]} {timestring}\n"); 
           printf("or: max_radius -1 target_name {jemx 0/1} {T_bin} {orbit low} {orbit high} {plt_offset} {group_sel}\n");
           printf(" NOTE: set T_bin = 0 if you dont want to generate batch files for fits2lc\n");
           return;
        }
        
        t_RA = atof(argv[2]);
        if (t_RA < 0.0) { 
           strcpy(iname, argv[3]);
           t_len = strlen(iname);
        } else t_dec = atof(argv[3]);
        
        if (argc > 4) jemx = atof(argv[4]);
        if (argc > 5) T_bin = atof(argv[5]);
        if (argc > 6) s_orbit_low = atoi(argv[6]);
        if (argc > 7) s_orbit_high = atoi(argv[7]);
        if (argc > 8) plot_offset = atof(argv[8]);
        if (argc > 9) group_select = atoi(argv[9]);
        if (argc > 10) strcpy(timestring, argv[10]);
        
        n_targ = -1;
        if (t_RA < 0.0) {
           sprintf(catname, "%s/reference/cat_combine.txt", sweethome);    
           cat = fopen(catname, "rt");
           if (cat == NULL) {printf("No catalog file found in %s\n", catname); return;}
           else printf("Opened catalog file\n");
              
           for (i=0; i<3000; i++) {
              if (i > srcnum) {
                 printf("Too many entries in the catalog: %6d, local srcnum maximum: %5d\n", i, srcnum);
                 return;
              } 

              fgets(iline, 300, cat);
              if (feof(cat)) goto p_enda;
              if (strlen(iline) < 10) continue;
           
              sscanf(iline, "%20c", catnames[i]);
              sscanf(&iline[21], "%f %f", &racat[i], &decat[i]);

              target = strstr(catnames[i], iname);
              if (target != NULL) n_targ = i;
           } 

p_enda: 
   	   imax = k;

           if (n_targ >= 0) {
              printf("Found catalog source: %s  ", catnames[n_targ]);
              printf("RA/dec:  %8.4f  ", racat[n_targ]);
              printf("%+8.4f\n", decat[n_targ]);
              t_RA = racat[n_targ];
              t_dec = decat[n_targ];
           } else {
              printf("Source: %s not found in catalog - exciting!\n", iname);
              fclose(cat);
              return;
           }
           
           fclose(cat);
   	} else sprintf(iname, "UIGR_%6.2lf_%6.2lf", t_RA, t_dec);
        
        printf("RA/dec: %10.8lf, %10.8lf, Src. name: %s, radius: %5.1f, orb lo/hi: %3d/%3d, survey_gr: %s", 
           t_RA, t_dec, iname, max_r, s_orbit_low, s_orbit_high, orbit);
        if (T_bin > 0.0) {
           printf(", T_bin: %5.1f", T_bin);
           gofil = fopen("go_f2lc", "wt");
           fprintf(gofil, "#! /bin/tcsh -f\n");
           fprintf(gofil, "rm -f *.chk\n");
           fprintf(gofil, "rm -f lc???.gnu\n");
           fprintf(gofil, "rm -f lc?.gnu\n");
        }
        
        printf("\n"); 
        
        for (ddd=0; ddd<=strlen(iname); ddd++) {
           if ((iname[ddd] == ' ') && (k == 0)) {
              for (k=0; k<198; k++) iname[k] = iname[k+1];
              k = 0;
              ddd--;
              continue;
           } else k = 1;
           if (iname[ddd] == ' ') iname[ddd] = '_';
           if (iname[ddd] == ',') iname[ddd] = '_';
           if (iname[ddd] == '/') iname[ddd] = '_';
        }
more_q: ddd = strlen(iname);
   	if (iname[ddd-1] == '_') {
           for (k=ddd-1; k<198; k++) iname[k] = iname[k+1];
           goto more_q;
        }

        tr_RA = t_RA / rad2g;
        tr_dec = t_dec / rad2g;
        
        X_target = cos(tr_dec) * cos(tr_RA);
        Y_target = cos(tr_dec) * sin(tr_RA);
        Z_target = sin(tr_dec);
        
        pointval = 0;
        sprintf(pointfil, "%s/pointing.dat", sweethome2);
        printf("Pointing file: %s\n", pointfil);
        pofil = fopen(pointfil, "rt");
        if (pofil == NULL) {
           printf("No pointing file found! (%s)\n", pointfil);
        } else {
           j = 0;
           T_sum = 0.0;
           for (i=0; i<1000000; i++) {
              fgets(dummy, 100, pofil);
              if (feof(pofil)) goto p_end;
              sscanf(dummy, "%d %d %d %lf %lf %f %d %d %d %d %d %d %f %f",
                 &p_orbit, &p_pid, &p_type, &p_RA, &p_dec, &p_posang, 
                 &p_year, &p_month, &p_day, &p_hour, &p_min, &p_sec, &p_durat, &p_IJD);
        
              sprintf(sw_group, ".");
                 
              if (group_select > 0) {
                 scwOK = 0;
                 if ((int)(group_select & 0x1) == 1) {
                    for (k=0; k<30; k++) sw_group[k] = 0; 
                    sprintf(sw_group, "survey");
                    scwOK += survey_chk(p_orbit, p_pid, sw_group, 1);
                    if (scwOK > 0) goto scw_hit;
                 }
                 if ((int)(group_select & 0x2) == 2) {
                    for (k=0; k<30; k++) sw_group[k] = 0; 
                    sprintf(sw_group, "pv");
                    scwOK += survey_chk(p_orbit, p_pid, sw_group, 2);
                    if (scwOK > 0) goto scw_hit; 
                 }
                 continue;
              }

scw_hit:
              if ((s_orbit_low > 0) && (p_orbit < s_orbit_low)) continue;
              if ((s_orbit_high > 0) && (p_orbit > s_orbit_high)) continue;
                 
/*            printf("%3d %3d %3d %8.4lf %8.4lf %8.4f %4d %2d %2d %2d %2d %2d %6.1f %10.6f\n",
              p_orbit, p_pid, p_type, p_RA, p_dec, p_posang, 
              p_year, p_month, p_day, p_hour, p_min, p_sec, p_durat, p_IJD);
*/
              j_RA = p_RA / rad2g;
              j_dec = p_dec / rad2g;
      
              Xcenter = cos(j_dec) * cos(j_RA);		/* X towards spring equinox */
              Ycenter = cos(j_dec) * sin(j_RA);		/* Y perpendicular to X and Z */
              Zcenter = sin(j_dec);			/* Z towards North */

              dist = sqrt((Xcenter - X_target) * (Xcenter - X_target) +
                 	  (Ycenter - Y_target) * (Ycenter - Y_target) +
                 	  (Zcenter - Z_target) * (Zcenter - Z_target));
              dist *= rad2g;	/* convert to degrees (only good for small angles, but OK here) */
              
              if (((dist < max_r) && ((p_type % 10) == 0) && (p_durat > 500.0))) {
                 j++;
                 T_sum += p_durat; 
                 if (T_bin > 0.0) 
                    fprintf(gofil, "./fits2lc_r %04d/r%1d_%03d_%04d_%03d.fits %s\n", 
                       p_orbit, jemx+1, p_orbit, p_pid, (int)(p_type/10 -1), iname);  
     printf("%4d orbit: %3d, pid: %3d, type: %3d, posang: %5.1f,  %4d%2d%2d %2d:%2d%2d, durat: %5.0f, dist: %8.3f\n",
        j, p_orbit, p_pid, p_type, p_posang, p_year, p_month, p_day, p_hour, p_min, p_sec, p_durat, dist);
/*     printf("Target XYZ: %8.3lf %8.3lf %8.3lf, Center RA/dec: %8.3lf %8.3lf XYZ: %8.3lf %8.3lf %8.3lf\n",
        X_target, Y_target, Z_target, p_RA, p_dec, Xcenter, Ycenter, Zcenter);
*/
              }
           }
        }
p_end:
        printf("Pointings within %5.1f degrees of RA/dec: %6.2f/%+5.2f. Number of scw: %3d, total time: %10.0f s\n",
           max_r, t_RA, t_dec, j, T_sum);

        sprintf(gnunavn, "gnu_%s_T%d", iname, (int)(T_bin));
        sprintf(gnunavn2, "%s_T%d", iname, (int)(T_bin));

        if (T_bin > 0.0) {
           fprintf(gofil, "gnuplot %s_E0\n", gnunavn);
           fprintf(gofil, "gnuplot %s_E1\n", gnunavn);
           fprintf(gofil, "gnuplot %s_E2\n", gnunavn);
           fprintf(gofil, "gnuplot %s_E3\n", gnunavn);
           fprintf(gofil, "cp lc4_0.gnu lc4_0_%s.gnu\n", gnunavn2);
           fprintf(gofil, "cp lc4_1.gnu lc4_1_%s.gnu\n", gnunavn2);
           fprintf(gofil, "cp lc4_2.gnu lc4_2_%s.gnu\n", gnunavn2);
           fprintf(gofil, "cp lc4_3.gnu lc4_3_%s.gnu\n", gnunavn2);
           fprintf(gofil, "cp lci_0.gnu lci_0_%s.gnu\n", gnunavn2);
           fprintf(gofil, "cp lci_1.gnu lci_1_%s.gnu\n", gnunavn2);
           fprintf(gofil, "cp lci_2.gnu lci_2_%s.gnu\n", gnunavn2);
           fprintf(gofil, "cp lci_3.gnu lci_3_%s.gnu\n", gnunavn2);
           fprintf(gofil, "cp lc8_1.gnu lc8_1_%s.gnu\n", gnunavn2);
           fprintf(gofil, "cp lcb.gnu lcb_%s.gnu\n", gnunavn2);
           fprintf(gofil, "cp lcc.gnu lcc_%s.gnu\n", gnunavn2);
           fprintf(gofil, "cp lcd.gnu lcd_%s.gnu\n", gnunavn2);
           fclose(gofil);
           k = 2000;
           gengnu(iname, s_orbit_low, T_bin, plot_offset, timestring, jemx);
           gendat(iname, t_RA, t_dec, T_bin, plot_offset);
        }   

        fclose(pofil);
}

/* **************************************************************** */

int survey_chk(int c_orbit, int c_pid, char *sw_group, int swgnum) 
{
   static int first = 0, orbit[10000], pid[10000], jmax = 0;
   FILE *in;
   char surveylist[200], iline[50], s_line[50];
   int jj, pidv;
   
   if ((first & swgnum) != swgnum) {
      sprintf(surveylist, "%s/reference/swids_of_group_%s.list", sweethome, sw_group); 
      in = fopen(surveylist, "rt") ;
      if ( in == NULL)
      {
         printf("Error opening file: %s ..... exiting!\n", surveylist) ;
         exit(0);
      }

      for (jj=0; jj<10000; jj++) {
              
         fgets(iline, 100, in);
         if (feof(in)) goto end;

         iline[12] = 0;
         strncpy(s_line, &iline[0], 4);
         s_line[4] = 0;
         orbit[jmax] = atoi(s_line);
      
         strncpy(s_line, &iline[4], 4);
         s_line[4] = 0;
         pid[jmax] = atoi(s_line);

         strncpy(s_line, &iline[8], 4);
         s_line[4] = 0;
         pidv = atoi(s_line);
         pidv = (pidv - 10) / 10;
         jmax++;
      }

end:  fclose(in);
      first |= swgnum;
      printf("jmax: %4d\n", jmax);
   }
   
   for (jj=0; jj<jmax; jj++) {
      if (orbit[jj] == c_orbit) {
         if (pid[jj] == c_pid) return(1);
      }
   }
   return(0);             
}

/* **************************************************************** */

void gengnu(char *datnavn, int orbit, float T_bin, double plot_offset, char *timestring, int jemx)
{
  FILE *df;
  char gnunavn[200], e_range[4][20];
  int ee;
   
  sprintf(e_range[0], "2-4");
  sprintf(e_range[1], "4-8");
  sprintf(e_range[2], "8-14");
  sprintf(e_range[3], "14-35");
  for (ee=0; ee<4; ee++) {
   sprintf(gnunavn, "gnu_%s_T%d_E%1d", datnavn, (int)(T_bin), ee);
   df = fopen(gnunavn, "wt");
   fprintf(df, "set title \"%s light curve, time_bin: %6.1f s  (JEM-X%1d)\"\n", datnavn, T_bin, jemx+1);
   if (strlen(timestring))
      fprintf(df, "set xlabel \"%s\"\n", timestring);
   else
      fprintf(df, "set xlabel \"Time (offset: %10.4lf days)\"\n", (double)(52564.1 - plot_offset));
   fprintf(df, "set ylabel \"Count rate cts/s per 100 cm2\"\n");
   fprintf(df, "set y2range [0:120]\n");
   fprintf(df, "#set yrange [0:60]\n");
   fprintf(df, "set y2tics \n");
   fprintf(df, "set terminal postscript color\n");
   fprintf(df, "set output \"dummy.ps\"\n");
   fprintf(df, 
   "plot \"lc4_%1d.gnu\" index 0 axes x1y1 title \"<- %s keV raw light curve\" with errorbars\n", 
      ee, e_range[ee]);
   fprintf(df, 
   "#replot \"lci_%1d.gnu\" index 0 axes x1y1 title \"<- %s keV comp. (4+pix) light curve \" with errorbars\n", 
      ee, e_range[ee]);
   fprintf(df, 
   "#replot \"lcj_%1d.gnu\" index 0 axes x1y1 title \"<- %s keV comp. (pix) light curve \" with errorbars\n", 
      ee, e_range[ee]);
   fprintf(df, 
   "#replot \"lca_%1d.gnu\" index 0 axes x1y1 title \"<- %s keV comp. (4) light curve \" with errorbars\n", 
      ee, e_range[ee]);
   fprintf(df, "replot \"lcb.gnu\" index 0 axes x1y1 title \"Zero\" with steps\n"); 
   fprintf(df, "replot \"lc8_1.gnu\" index 0 axes x1y2 title \"Illum. area cm2 ->\" with steps\n");
   fprintf(df, "#replot \"lcc.gnu\" index 0 axes x1y2 title \"pid / 10 ->\" with points\n"); 
   fprintf(df, "#replot \"lcd.gnu\" index 0 axes x1y2 title \"pid % 10 ->\" with points\n"); 
   fprintf(df, "#replot \"lc3.gnu\" index 0 axes x1y2 title \"Livetime/point(%) ->\" with points\n");

   fprintf(df, "set output \"%s_T%d_E%1d.ps\"\n", datnavn, (int)(T_bin), ee);
   fprintf(df, "replot\n");
   fclose(df);
  }
}

/* **************************************************************** */

void gendat(char *datnavn, float RA, float dec, float T_bin, double plot_offset)
{
  FILE *df;
  char navn[200];
  
  sprintf(navn, "%s.dat", datnavn);
  df = fopen(navn, "wt");
  fprintf(df, "%8.4f %8.4f %8.4f %10.5lf\n", RA, dec, T_bin, plot_offset);
  fclose(df);
}  

